# Used when bootstrapping new python major version
%bcond_with bootstrap

Name:           python-rpm-generators
Summary:        Dependency generators for Python RPMs
Group:		System/Packaging
Version:        12
Release:        %mkrel 11

# Originally all those files were part of RPM, so license is kept here
License:        GPLv2+
Url:            https://src.fedoraproject.org/python-rpm-generators
# Commit is the last change in following files
Source0:        https://raw.githubusercontent.com/rpm-software-management/rpm/102eab50b3d0d6546dfe082eac0ade21e6b3dbf1/COPYING
Source1:        python.attr
Source2:        pythondist.attr
Source3:        pythonname.attr
Source4:        pythondistdeps.py
Source5:        pythonbundles.py

# Mageia specific
Source10:	do-not-emit-rich-deps.patch

BuildArch:      noarch

%description
%{summary}.

%package -n python3-rpm-generators
Summary:        %{summary}
%if ! %{with bootstrap}
Requires:       python3-packaging
%endif
# We have parametric macro generators, we need RPM 4.16 (4.15.90+ is 4.16 alpha)
Requires:       rpm > 4.15.90-0
# This contains the Lua functions we use:
Requires:       python-srpm-macros >= 3.8-5

%description -n python3-rpm-generators
%{summary}.

%prep
%autosetup -c -T
cp -a %{sources} .

patch -p1 < %SOURCE10

%install
install -Dpm0644 -t %{buildroot}%{_fileattrsdir} *.attr
install -Dpm0755 -t %{buildroot}%{_rpmconfigdir} *.py

%files -n python3-rpm-generators
%license COPYING
%{_fileattrsdir}/python.attr
%{_fileattrsdir}/pythondist.attr
%{_fileattrsdir}/pythonname.attr
%{_rpmconfigdir}/pythondistdeps.py
%{_rpmconfigdir}/pythonbundles.py


%changelog
* Thu Dec 07 2023 wally <wally> 12-11.mga10
+ Revision: 2014575
- non-bootstrap build for py3.12 update

* Thu Dec 07 2023 wally <wally> 12-10.mga10
+ Revision: 2014393
- bootstrap build for py3.12 update

* Fri Jan 06 2023 wally <wally> 12-9.mga9
+ Revision: 1930549
- add namespace option to pythodistdeps.py to allow mingw-python generators
- fail python pkg build if generated python3dist() provides version is 0
  (can be bypassed if _python_dist_allow_version_zero is defined in pkg .spec)

* Mon Mar 21 2022 umeabot <umeabot> 12-8.mga9
+ Revision: 1816062
- Mageia 9 Mass Rebuild

* Sat Feb 05 2022 wally <wally> 12-7.mga9
+ Revision: 1771734
- fix skip rich deps patch
- disable bootstrap build

* Sat Feb 05 2022 wally <wally> 12-5.mga9
+ Revision: 1771576
- bootstrap build for upcoming python3.10
- sync with Fedora where appropriate

* Fri Jun 25 2021 wally <wally> 12-4.mga9
+ Revision: 1732259
- sync scripts with Fedora where appropriate

* Sun Mar 14 2021 wally <wally> 12-3.mga9
+ Revision: 1702609
- disable bootstrap

* Sun Mar 14 2021 wally <wally> 12-2.mga9
+ Revision: 1702507
- bootstrap build for new python 3.9

* Sat Mar 13 2021 wally <wally> 12-1.mga9
+ Revision: 1702203
- sync with Fedora

* Sat Oct 03 2020 tv <tv> 11-4.mga8
+ Revision: 1631929
- do not emit " or " rich deps
- pythondistdeps: Split Python Extras names after the rightmost plus sign
- pythondistdeps: Handle edge cases of version comparisons more closely to
  upstream, despite irrationality
  See: https://github.com/pypa/packaging/issues/320
- pythondistdeps: Implement provides/requires for extras packages
- Enable --require-extras-subpackages
- Adapt Python version marker workaround for setuptools 42+
- Fix python(abi) requires generator, it picked files from almost good directories
- Add a script to generate Python bundled provides

* Tue Apr 21 2020 tv <tv> 11-3.mga8
+ Revision: 1570229
- Handle all-zero versions without crashing

* Mon Apr 20 2020 tv <tv> 11-2.mga8
+ Revision: 1570107
- do not emit rich deps in all cases

* Fri Apr 17 2020 tv <tv> 11-1.mga8
+ Revision: 1568514
- do not emit rich deps

* Tue Apr 14 2020 tv <tv> 11-0.1.mga8
+ Revision: 1567317
- sync with FC:
  o Sync with upstream RPM dist generator
  o Rewrite python(abi) generators to Lua to make them faster
  o RPM 4.16+ is needed
+ wally <wally>
- non-bootstrap build for python3.8

* Tue Sep 03 2019 wally <wally> 4.14.2-7.mga8
+ Revision: 1436689
- bootstrap build for python3.8

* Fri Jan 04 2019 wally <wally> 4.14.2-6.mga7
+ Revision: 1349185
- disable bootstrap mode

* Fri Jan 04 2019 wally <wally> 4.14.2-5.mga7
+ Revision: 1349071
- enable bootstrap mode for python3.7 update

* Mon Sep 24 2018 tv <tv> 4.14.2-4.mga7
+ Revision: 1303666
- unset bootstrapping_python

* Mon Sep 24 2018 tv <tv> 4.14.2-3.mga7
+ Revision: 1303613
- set bootstrapping_python

* Thu Sep 20 2018 umeabot <umeabot> 4.14.2-2.mga7
+ Revision: 1290005
- Mageia 7 Mass Rebuild

* Sat Sep 15 2018 ngompa <ngompa> 4.14.2-1.mga7
+ Revision: 1259094
- Rebase to RPM version 4.14.2
- Drop all patches incorporated upstream
- Backport upstreamed pythondistdeps fileattr
- Refresh Mageia-specific patches

* Mon Aug 07 2017 ngompa <ngompa> 4.13.0.1-2.6.mga7
+ Revision: 1138203
- Enable pythondistdeps Requires generator

* Thu Aug 03 2017 philippem <philippem> 4.13.0.1-2.5.mga7
+ Revision: 1134396
- remove bootstrap

* Sat Jul 29 2017 philippem <philippem> 4.13.0.1-2.4.mga7
+ Revision: 1132451
- bootstraping for python 3.6.2
- we now have python 3.6.2

* Fri Jul 28 2017 philippem <philippem> 4.13.0.1-2.3.mga7
+ Revision: 1132087
- first step for Python 3.6.2

* Thu Jul 20 2017 tv <tv> 4.13.0.1-2.2.mga7
+ Revision: 1125489
- make conflict tag more strict

* Thu Jul 20 2017 tv <tv> 4.13.0.1-2.1.mga7
+ Revision: 1125471
- output legacy provides for compatibility for now
- use %%mkrel

* Thu Jul 20 2017 tv <tv> 4.13.0.1-2.mga7
+ Revision: 1125461
- imported package python-rpm-generators


* Thu Jul 20 2017 Thierry Vignaud <tv@mageia.org> 4.13.0.1-2.mga7
- import from FC

* Thu May 18 2017 Tomas Orsava <torsava@redhat.com> - 4.13.0.1-2
- Added a license file
- Added a dependency on rpm for the proper directory structure
- Properly owning the __pycache__ directory

* Tue May 02 2017 Tomas Orsava <torsava@redhat.com> - 4.13.0.1-1
- Splitting Python RPM generators from the `rpm` package to standalone one
